kernel_blur_otpw(img[3][R][C], blury[3][R-2][C-2])
  __shared__ blurx[blockDim.y][blockDim.x/warpSize][tile*warpSize+2]
  y = blockIdx.y * blockDim.y + threadIdx.y;
  c = threadIdx.z;
  warp_xx = threadIdx.x/warpSize;
  for (tx = 0; tx < tile+1; tx++) |\label{line:otpw:blurx-loop-starts}|
    xx = tx*warpSize + threadIdx.x%warpSize;
    x = blockIdx.x*blockDim.x*tx + blockDim.x*tx + threadIdx.x;
    if (xx < tile*warpSize+2)
      blurx[y][warp_xx][xx]=(img[c][y-1][x]+img[c][y][x]+img[c][y+1][x])/3; |\label{line:otpw:blurx-loop-ends}|
  __syncwarp ();|\label{line:otpw:syncwarp}|
  for (tx = 0; tx < tile+1; tx++) |\label{line:otpw:blury-loop-starts}|
    xx = tx*warpSize + threadIdx.x%warpSize;
    x = blockIdx.x*blockDim.x*tx + blockDim.x*tx + threadIdx.x;
    blury[c][y][x] = (blurx[y][warp_xx][xx-1]+ blurx[y][warp_xx][xx]+ 
                      blurx[y][warp_xx][xx+1])/3;|\label{line:otpw:blury-loop-ends}|
