blur_otpw_ht(img[3][R][C], blury[3][R-2][C-2])
  shared blurx[blockDim.y][blockDim.x/warpSz]
              [tile/2*warpSz+2];
  y = blockIdx.y * blockDim.y+threadIdx.y;
  c = threadIdx.z;
  warpSz = warpSize;
  warp = threadIdx.x/warpSz;
   
  for(tx = 0; tx < 2; tx++) |\label{line:otpw-hybrid:blurx-shared-start}|
   for(txx = tx*tile/4;txx<(tx+1)*tile/4+1;txx++)
    xx = tile*warpSz+threadIdx.x%warpSz;
    x = (blockIdx.x+1)*blockDim.x*tx+threadIdx.x;
    if(xx < tile*warpSz+2)
     blurx[y][warp][xx] = (img[c][y-1][x]+
     img[c][y][x]+img[c][y+1][x])/3;|\label{line:otpw-hybrid:blurx-shared-end}|
  x = warp_idx+8*warpSz+lane_id_x; |\label{line:otpw-hybrid:blurx-reg-8}|
  blurx_8 = (img[c][y-1][x]+img[c][y][x] +
             img[c][y+1][x])/3;
  x = warp_idx+9*warpSz+lane_id_x;
  blurx_9 = (img[c][y-1][x]+img[c][y][x]+
             img[c][y+1][x])/3; 
  /*similarly, for all iterations till 15*/|\label{line:otpw-hybrid:blurx-reg-15}|
  syncwarp();
  for(tx = 0; tx < 2; tx++)|\label{line:otpw-hybrid:blury-shared-start}|
   for(txx = tx*tile/4; txx <(tx+1)*tile/4; txx++)
    xx = tile*warpSz+threadIdx.x%warpSz;
    x = (blockIdx.x+1)*blockDim.x*tx+threadIdx.x;
    if(xx > 0 and xx < tile/2*warpSz+2)
     blury[c][y][x] = (blurx[y][warp][xx-1]+
      blurx[y][warp][xx]+blurx[y][warp][xx+1])/3;|\label{line:otpw-hybrid:blury-shared-end}|
  blurx_l_2_8 = shfl_up(FULL_MASK, blurx_8, 2);  |\label{line:otpw:blury-reg-blurx_l_2_8}|
  blurx_l_1_8 = shfl_up(FULL_MASK, blurx_8, 1);  |\label{line:otpw:blury-reg-blurx_l_1_8}|
  if(lane_id_x == 0) |\label{line:otpw:blury-reg-blurx_8_sh_mem-start}|
   blurx_l_2_8=blurx[y][warp][7*warpSz+warpSz-2];
   blurx_l_1_8=blurx[y][warp][7*warpSz+warpSz-1];
  if(lane_id_x == 1) 
   blurx_l_2_8=blurx[y][warp][7*warpSz+warpSz-1];|\label{line:otpw:blury-reg-blurx_8_sh_mem-end}|
  x = warp_idx+8*warpSz+lane_id_x;
  blury[c][y][x] = (blurx_l_2_8+blurx_l_1_8+
                    blurx_8)/3;|\label{line:otpw:blury-reg-8}|
  blurx_l_2_9 = shfl_up(FULL_MASK, blurx_9, 2); |\label{line:otpw:blury-reg-9-prev-start}|
  blurx_l_1_9 = shfl_up(FULL_MASK, blurx_9, 1);
  _blurx_l_2_9=shfl(FULL_MASK, blurx_8, warpSz-2);
  _blurx_l_1_9=shfl(FULL_MASK, blurx_8, warpSz-1);
  if(lane_id_x == 0) 
    blurx_l_1_9 = _blurx_l_1_9;
    blurx_l_2_9 = _blurx_l_2_9;
  if(lane_id_x == 1) blurx_l_2_9 = _blurx_l_1_9; |\label{line:otpw:blury-reg-9-prev-end}|
  x = warp_idx+9*warpSz+lane_id_x;  
  blury[c][y][x] = (blurx_l_2_9+blurx_l_1_9+
                    blurx_9)/3; |\label{line:otpw:blury-reg-9}|
  /*similarly, for all iterations till 15*/
